/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of FastSearch.xs. Do not edit this file, edit FastSearch.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FastSearch.xs"
/* $Id: FastSearch.xs,v 1.1.1.1 2006/04/28 07:35:51 kiesling Exp $  */
/* Derived from the encdec.c program posted to              */
/* comp.mail.mime.                                          */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdio.h>
#include <errno.h>

extern int errno;

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int len, int arg)
{
    errno = EINVAL;
    return 0;
}

/* 
   Search_buffer () uses the Boyer-Moore algorithm's technique 
   of searching from the rightmost character of the pattern 
   string.  It does not maintain a skip table due to the 
   overhead of Perl memory allocation.

   Returns a -1 terminated array of match positions in the offets
   argument.
*/
void
search_buffer (char *pattern, char *buffer, long long *offsets) {

  int s, skip;
  long long n;
  int n_offsets;
  int buffer_length, searchable_length;
  int pattern_length;
  char *p, c;

  buffer_length = strlen (buffer) - 1;
  pattern_length = strlen (pattern) - 1;
  if (buffer_length < pattern_length) {
    offsets[0] = -1L;
    return;
  }
  searchable_length = buffer_length - pattern_length;

  n_offsets = 0;
  n = 0L;
  while (n <= searchable_length) {
    skip = 0;
    for (s = pattern_length; s >= 0; s--) {
      if (pattern[s] == buffer[n + s]) {
	++skip;
      } else {
	++n;
	break;
      }
    }
    if (s < 0) {
      offsets[n_offsets++] = n;
      offsets[n_offsets] = -1;
    }
    n += skip;
  }
}

#line 84 "FastSearch.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 228 "FastSearch.c"

XS_EUPXS(XS_Text__FastSearch_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__FastSearch_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
#line 81 "FastSearch.xs"
	STRLEN		len;
#line 239 "FastSearch.c"
	SV *	sv = ST(0)
;
	char *	s = SvPV(sv, len);
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;
#line 87 "FastSearch.xs"
	RETVAL = constant(s,len,arg);
#line 249 "FastSearch.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__FastSearch__strindex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__FastSearch__strindex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pattern, buffer");
    {
	char *	pattern = SvPV (ST(0), PL_na);
	char *	buffer = SvPV (ST(1), PL_na);
#line 96 "FastSearch.xs"
        long long offsets[0xFFFF];
        char nbuf[64];
#line 268 "FastSearch.c"
	SV *	RETVAL;
#line 99 "FastSearch.xs"
        offsets[0] = -1;
        search_buffer (pattern, buffer, offsets);
        if (offsets[0] == -1) 
	    XSRETURN_UNDEF;
	else 
            sprintf (nbuf, "%ld", offsets[0]);
	    RETVAL = newSVpv (nbuf, strlen(nbuf));
#line 278 "FastSearch.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__FastSearch__search_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__FastSearch__search_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pattern, buffer");
    {
	char *	pattern = SvPV (ST(0), PL_na);
	char *	buffer = SvPV (ST(1), PL_na);
#line 114 "FastSearch.xs"
  	    int n;
            long long offsets[0xFFFF];
	    char nbuf[32];
#line 299 "FastSearch.c"
	AV *	RETVAL;
#line 118 "FastSearch.xs"
	  RETVAL = newAV();
	  offsets[0] = -1;
          search_buffer (pattern, buffer, offsets);
          if (offsets[0] >= 0) {
              for (n = 0; offsets[n] >= 0; n++) {
              sprintf (nbuf, "%ld", offsets[n]);
	      av_push (RETVAL, newSVpv (nbuf, strlen(nbuf)));
              }
	  }
#line 311 "FastSearch.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
#line 130 "FastSearch.xs"
          SvREFCNT_dec (RETVAL);
#line 320 "FastSearch.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__FastSearch__search_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__FastSearch__search_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pattern, fn");
    {
	char *	pattern = SvPV (ST(0), PL_na);
	char *	fn = SvPV (ST(1), PL_na);
#line 138 "FastSearch.xs"
       int n, a, pattern_length, overlap;
       long long bufstart, offsets[0xFFFF];
       FILE *f;
       char buf[0xFFFF], nbuf[64];
       int r;
#line 341 "FastSearch.c"
	AV *	RETVAL;
#line 144 "FastSearch.xs"
       RETVAL = newAV();
       pattern_length = strlen (pattern);
       overlap = 0;
       a = 0;
       bufstart = 0L;
       if ((f = fopen (fn, "r")) != NULL) {
	 while (!feof(f)) {
	   r = fread (&buf[overlap], sizeof (char), 0xFFFF - overlap, f);
           if (!r) break;
           offsets[0] = -1L;
	   search_buffer (pattern, buf, offsets);
           for (n = 0; offsets[n] >= 0L; n++, a++) {
	     sprintf (nbuf, "%ld", offsets[n] + bufstart - overlap);
	     av_push (RETVAL, newSVpv (nbuf, strlen (nbuf)));
           }
	   memmove (buf, &buf[r - overlap], overlap*sizeof(char));
	   bufstart += (long long)r;
	   offsets[0] = -1L;
	   overlap = pattern_length;
	 }
	 fclose (f);
       } else {
	 XSRETURN_UNDEF;
       }
#line 368 "FastSearch.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
#line 171 "FastSearch.xs"
       SvREFCNT_dec (RETVAL);
#line 377 "FastSearch.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Text__FastSearch); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__FastSearch)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Text::FastSearch::constant", XS_Text__FastSearch_constant);
        newXS_deffile("Text::FastSearch::_strindex", XS_Text__FastSearch__strindex);
        newXS_deffile("Text::FastSearch::_search_string", XS_Text__FastSearch__search_string);
        newXS_deffile("Text::FastSearch::_search_file", XS_Text__FastSearch__search_file);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

